#include <stdio.h>
#define BYTE unsigned char
#define WORD unsigned short int
#define EMP 0xff
#define GOOD_ATT 57
#define ORC_ATT 10
#define ORC_HEIGHT 4
/*const int BUL_U (-24);
const int BUL_D (424);
const int BUL_R (-37);
const int BUL_L (677);
#define OBSC_U -12
#define OBSC_D 400
#define OBSC_R -12
#define OBSC_L 640*/
#define GOOD_HEIGHT 32
#define ORC_WIDTH 4
#define GOOD_WIDTH 32
#define ORC_VISION 800
#define ORC_TOOCLOSE 6
#define GEN_HEALTH 127
//unused
//#define alleg_mouse_unused
//#define alleg_timer_unused
//#define alleg_keyboard_unused
#define alleg_joystick_unused
#define alleg_flic_unused
//#define alleg_sound_unused
#define alleg_math_unused
//#define alleg_gui_unused

#include "allegro.h"
#include "tiles.h"
#include "game.h"
#include "obj.h"
DECLARE_GFX_DRIVER_LIST(
   GFX_DRIVER_VBEAF
   GFX_DRIVER_VESA3
   GFX_DRIVER_VESA2B
   GFX_DRIVER_VESA2L
   GFX_DRIVER_ATI
   GFX_DRIVER_MACH64
   GFX_DRIVER_CIRRUS64
   GFX_DRIVER_CIRRUS54
   GFX_DRIVER_PARADISE
   GFX_DRIVER_S3
   GFX_DRIVER_TRIDENT
   GFX_DRIVER_ET3000
   GFX_DRIVER_ET4000
   GFX_DRIVER_ET6000
   GFX_DRIVER_VIDEO7
   GFX_DRIVER_VESA1
   );
DECLARE_COLOR_DEPTH_LIST(COLOR_DEPTH_8);
#include "dat.h"
void sort_init();
void load_map(char *mapfile);
void draw_map();
void init_good();
BYTE can_move(long cax, long cay);
int whois_bul(int wx, int wy, BYTE ktype);
int whois();
void game_menu(BYTE mode);
void briefing(char *pcxfile);
void destroy_map();
void next_level();
void init_game();


WORD randseed1=20; /* for my not-quite-random number generator */
WORD randseed2=75;
WORD randnum,randrange;
signed char lives;
int wizn;
//#define wizard1 obj[wizn]
char level;
BYTE ctrl_p=0;
char lastlevel=5;
char *levs[7] = { "l", "l1.wmp","l2.wmp","l3.wmp","l4.wmp","l5.wmp" };
char *bravos[7] = { "l", "","","","You have completed this game","" };
char *briefs[7] = { "l", "Your objective is to kill all enemies",
"Your objective is to find the exit","Your objective is to kill all enemies",
"Your objective is to find the exit","Your objective is to find the exit" };
//BYTE mouse_p1=0, mouse_p2=0;
WORD *tow;
WORD sort_i;
WORD m_i, d_i;
// l = 10, h=80
enum { JOHN=0, ORC, ARROW, BOSS1};
enum { T_UNM=0, T_GR};
enum { CLEVER, STUPID };
enum { key_d=1, key_dr=3, key_r=2, key_ur=6, key_u=4, key_ul=12, key_l=8, key_dl=9 };
enum { dir_d=1, dir_dr=3, dir_r=2, dir_ur=6, dir_u=4, dir_ul=12, dir_l=8, dir_dl=9 };
enum { bul_d=0, bul_dr, bul_r, bul_ur, bul_u, bul_ul, bul_l, bul_dl };
enum { cmd_up, cmd_down, cmd_left, cmd_right, cmd_nocmd, cmd_esc,
 cmd_upleft, cmd_downleft, cmd_upright, cmd_downright, cmd_die, cmd_idle,
 cmd_att, cmd_move, cmd_back};
enum {hd1=0, hd2, hd3, hd4, hdr1, hdr2, hdr3, hdr4,
hr1, hr2, hr3, hr4, hur1, hur2, hur3, hur4, hu1, hu2, hu3,
hu4, hul1, hul2, hul3, hul4, hl1, hl2, hl3, hl4, hdl1, hdl2,
hdl3, hdl4,
//==============
had1, hadr1, har1, haur1,  hau1, haul1, hal1,  hadl1,
//==============
hdied1, hdied2, hdied3, hdied4, hdiedr1, hdiedr2, hdiedr3, hdiedr4,
hdier1, hdier2, hdier3, hdier4, hdieur1, hdieur2, hdieur3, hdieur4, hdieu1,
hdieu2, hdieu3, hdieu4, hdieul1, hdieul2, hdieul3, hdieul4, hdiel1, hdiel2,
hdiel3, hdiel4, hdiedl1, hdiedl2, hdiedl3, hdiedl4,
//===============
hsd=80, hsdr,hsr,hsur,hsu,hsul,hsl,hsdl };                             // 32

enum {od1=0, od2, od3, od4, odr1, odr2, odr3, odr4,
or1, or2, or3, or4, our1, our2, our3, our4, ou1, ou2, ou3,
ou4, oul1, oul2, oul3, oul4, ol1, ol2, ol3, ol4, odl1, odl2,
odl3, odl4,
//==============
oad1, oadr1, oar1, oaur1,  oau1, oaul1, oal1,  oadl1,
//==============
odied1, odied2, odied3, odied4, odiedr1, odiedr2, odiedr3, odiedr4,
odier1, odier2, odier3, odier4, odieur1, odieur2, odieur3, odieur4, odieu1,
odieu2, odieu3, odieu4, odieul1, odieul2, odieul3, odieul4, odiel1, odiel2,
odiel3, odiel4, odiedl1, odiedl2, odiedl3, odiedl4,
//===============
osd=80, osdr,osr,osur,osu,osul,osl,osdl };                             // 32

// na wsqka poza ->nextpose , fr -> w_fr [pose]
//                   0  1  2  3  4  5  6  7  8   9  10 11  12
WORD nextpose[112]= {1, 2, 3, 0, 5, 6, 7, 4, 9, 10, 11, 8, 13,    //13
//                   13  14  15  16  17  18   19 20  21  22  23
                     14, 15, 12, 17, 18, 19, 16, 21, 22, 23, 20, //11
//                   24  25  26  27  28  29  30  31  32  33  34   // 31 act
                     25, 26, 27, 24, 29, 30, 31, 28, hsd,hsdr,hsr,
//                   35  36  37  38   39  40  41  42  43  44  45
                   hsur,hsu,hsul,hsl,hsdl,41, 42, 43, 44, 44, 46,
//                   46  47  48  49  50  51  52  53  54  55  56   //4
                     47, 48, 49, 49, 51, 52, 53, 54, 54, 56, 57,
//                   57  58  59  60  61  62  63  64  65  66  67
                     58, 59, 59, 61, 62, 63, 64, 64, 66, 67, 68,
//                   68  69  70  71  72  73  74  75  76  77  78
                     69, 69, 71, 72, 73, 74, 74, 76, 77, 78, 79,
//                   79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89,
                     79, 80, 81, 82, 83, 84, 85, 86, 87};//, 88, 88, 90,
//                   90, 91  92, 93, 94, 95, 96, 97, 98, 99,100,//2
//                   91, 92, 93, 93, 95, 96, 97, 98, 98,100,101,
//                   101 102  103d104 105 106 107 108 109 110 111
//                   102,103, 103,104,105,106,107,108,109,110,111
//                     };

//                  0  1  2  3  4  5  6  7  8   9   0 11  12
WORD w_frame[112]=  {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12,     //13
//                   13  14  15  16  17  18   19 20  21  22  23
                     13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, //11
//                   24  25  26  27  28  29  30  31  32  33  34
                     24, 25, 26, 27, 28, 29, 30, 31,  1,  5, 9,
//                   35  36  37  38  39  40  41  42  43  44  45
                     13, 17, 21, 25, 29, 32, 33, 34, 35, EMP,36,   //6
//                   46  47  48  49  50  51  52  53  54  55  56
                     37, 38, 39,EMP, 40, 41, 42, 43,EMP, 44, 45,    //11=17
//                   57  58  59  60  61  62  63  64  65  66, 67  68  69
                     46, 47,EMP, 48 ,49, 50, 51,EMP, 52, 53, 54, 55,EMP,
//                   70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81
                     56, 57, 58, 59,EMP, 60, 61, 62, 63, EMP, 1,  5,
//                   82, 83,  84, 85, 86, 87, 88  89  90  91  92
                     9,  13,  17, 21, 25, 29};//, 76, 77, 78, 79,
//                   93, 94, 95, 96, 97, 98, 99, 100,101,102,103,104,105
//                     EMP,80, 81, 82, 83,EMP, 84, 85,  86, 87,EMP, 32, 35,
//                   106 107 108 109 110 111
//                     38, 41, 44, 47, 50, 53
//                    };//1,5,9

//                  0  1  2  3  4  5  6  7  8  9  0
BYTE posedelay[112]={5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,  //20
                    5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,  //20
                    5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,  //20
                    5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,  //20
                    5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,  //20
                    5,5,5,5,5,5,5,5,5,5,5,5                   //12
                   };
typedef struct _lin {
   int x, y;
   };
BYTE path_i, path_dir ;
int path_dx, path_dy, path_tx, path_ty, path_d2x, path_d2y;

typedef struct sprg {
	     int x, y, tox, toy, nx,ny;
        int cl,ll;
        int scrx, scry       ;
	     int frame, pose      ;
        BYTE  is, type, vis, subtype, del ;
        signed char incx, incy, am;
        double d;
	     signed char health;       // 0 - 120
	     BYTE weapon, damage;
        int att; //attacking (who)
        WORD shot_freq;
        BYTE dir, shot;
        BYTE command, keyc, keylc;
	   };
typedef struct _bul {
	     int x, y, scrx, scry;
	     int frame;
        BYTE  is, type, ktype;
        signed char damage, xdir, ydir;
	   };

typedef struct _obj {
	     int x, y, scrx, scry;
	     int frame;
        BYTE  is,vis, type;
	   };

typedef struct _gen {
	     int x, y;//, scrx, scry;
        BYTE  is, type;
        signed char health, orcs_left;
	   };

typedef struct _red {
        int nr;
        BYTE  *is, *type;
        int *y;
	   };

int b_frame;
signed char b_dirx, b_diry;
#define DAM_JOHN 1
#define DAM_ORC  1
#define BAM 6
typedef struct _ctr {
   BYTE x, y;
   };
typedef struct _ctr2 {
   signed char x, y;
   };
//ctr2 - signned| ctr - unsigned
_ctr ctr_g[JOHN_DAT];
_ctr ctr_o[ORC_DAT];
_ctr ctr_bul[BUL_DAT]; // drawing bullets
_ctr2 ctr_bstg[BUL_DAT]; // starting pos for buls for john
_ctr2 ctr_bsto[BUL_DAT]; // starting pos for buls for orcs

const int MAXBAD = 100;
const int MAXBULS = 20;
const int MAXGEN = 10;
const int MAXOBJ = 20;

sprg all[MAXBAD]; // all actors
_gen gen[MAXGEN]; // generators of creatures
_bul bul[MAXBULS]; // arrows, etc.
//OB means object| these are all object types
_obj obj[MAXOBJ];   // objects - keys, rings, people
enum { OT_GROUND=0, OT_WATER=253, OT_WALL=254 };
signed char flag[32];     //flags
_red sort_tem;
_red redica[MAXBAD+MAXBULS];
int lastbad, lastbul=(MAXBULS-1), enemy_left,
lastred=(MAXBAD+MAXBULS-1), lastgen=0, lastobj;
#define good all[0]

DATAFILE *goodpics, *bulpics, *opics, *objpics;

//============================================================== map
 ldiv_t canm_x, canm_y;
BYTE canm_type;
WORD loco;
BITMAP *dbuff;
int *getwh;
typedef struct SCREEN {
	     int width, height, card ;
        long lmar, rmar, umar, dmar;
	     WORD t_width, t_height ;
        volatile WORD fps;//, av_fps , min_fps, max_fps;
        int gspeed;
	   };
SCREEN scr;
BYTE strx[25], stry[25], strm[25];
BYTE quit ;

DATAFILE *tiles, *gamedat, *o_tiles;
 int ty, tx, tsx, tsy, umn, umn1, umny;

 typedef struct
{
	WORD width, height;				// width and height of map, in tiles
	long w_width, w_height; 			// world width and height, in pixels
	BYTE t_width, t_height;			// width and height of tiles 16,16
	char sh_width;						// number of bits to shift for
	char sh_height; 					// multiplying by the width or
   long x,y;
   BYTE am;
   ldiv_t m_x, m_y;
   WORD *data[1000];
   int scrwidth, scrheight;
   WORD popup_rate;
} MAP;

MAP map;

//====================================================== game stuff

void game_exit()
{
destroy_map();
remove_timer();
remove_mouse();
remove_keyboard();
set_gfx_mode(GFX_TEXT, 80, 25, 0, 0);
unload_datafile(tiles);
unload_datafile(objpics);
 unload_datafile(o_tiles);
unload_datafile(goodpics);
unload_datafile(bulpics);
unload_datafile(opics);
unload_datafile(gamedat);
stop_midi();
//remove_mouse();
//printf("average: %u , lowest: %u , highest: %u, lastl %u ", scr.av_fps,
//scr.min_fps, scr.max_fps, lastbad);
printf("\nAuthor: Evgeni Petkov\n");
printf("e-mail: e_petkov@hotmail.com\n");
printf("Please send me any comments you have about this game.\n");
//printf("or if you have found any errors.\n");
allegro_exit();
exit(0);
}

void init_game()
{
int i;
for(i=0; i<32; i++)
{
flag[i]=0;
}
map.w_width=map.width*map.t_width - map.t_width*2 - good.am -5;
map.w_height=map.height*map.t_height - map.t_height*2 - good.am;
scr.t_width=scr.width/map.t_width +1;
scr.t_height=scr.height/map.t_height +1;
map.scrheight=(map.height*map.t_height) - scr.height - map.t_height*2;
map.scrwidth=(map.width*map.t_width) - scr.width - map.t_width*2;
}

void restart_game()
{
level=1;
lives=5;
briefing(briefs[level]);
switch (level)
{
case 1 : play_midi((MIDI *)gamedat[L1_MID].dat, TRUE);break;
case 2 : play_midi((MIDI *)gamedat[L2_MID].dat, TRUE);break;
case 3 : play_midi((MIDI *)gamedat[L3_MID].dat, TRUE);break;
case 4 : play_midi((MIDI *)gamedat[L4_MID].dat, TRUE);break;
}
load_map(levs[level]);
init_game();
init_good();
sort_init();
}

void restart_level()
{
briefing(briefs[level]);
switch (level)
{
case 1 : play_midi((MIDI *)gamedat[L1_MID].dat, TRUE);break;
case 2 : play_midi((MIDI *)gamedat[L2_MID].dat, TRUE);break;
case 3 : play_midi((MIDI *)gamedat[L3_MID].dat, TRUE);break;
case 4 : play_midi((MIDI *)gamedat[L4_MID].dat, TRUE);break;
}
load_map(levs[level]);
init_game();
init_good();
sort_init();
}

void change_mode()
{
int tw, th, tc;
if (gfx_mode_select(&tc, &tw, &th) )
      {
      scr.width=tw;
      scr.height=th;
      scr.card=tc;
      show_mouse(NULL);
 set_gfx_mode(scr.card, scr.width, scr.height, 0, 0);
destroy_bitmap(dbuff);
dbuff=create_bitmap(scr.width, scr.height);
clear(dbuff);
set_clip(dbuff, 0, 0,
scr.width , scr.height );
 set_palette((PALLETE )gamedat[GPAL].dat);
scr.t_width=scr.width/map.t_width +1;
scr.t_height=scr.height/map.t_height +1;
map.scrheight=(map.height*map.t_height) - scr.height - map.t_height*2;
map.scrwidth=(map.width*map.t_width) - scr.width - map.t_width*2;
           good.scrx=320;
           good.scry=200;
           map.x=good.x - good.scrx;
           map.y=good.y - good.scry;
           if (good.x <= good.scrx) {map.x=0;good.scrx=good.x;}
           if (good.y <= good.scry) {map.y=0;good.scry=good.y;}
if (scr.width > 600)
  {
scr.lmar= 6*map.t_width;
scr.rmar= scr.width - 6*map.t_width;
  } else
  {
scr.lmar= 3*map.t_width;
scr.rmar= scr.width - 3*map.t_width;
  }
if (scr.height > 300)
  {
scr.umar= 6*map.t_height;
scr.dmar= scr.height - 6*map.t_height;
  }  else
  {
scr.umar= 3*map.t_height;
scr.dmar= scr.height - 3*map.t_height;
  }
    return;
    } else return;
}

void game_menu(BYTE mode)
{
int pr[10];
int focus[10];
//BITMAP *temp;
//RGB *tp;
play_midi((MIDI *)gamedat[TITLE_MID].dat, TRUE);
ghr:
int gmex=0;
show_mouse(NULL);
//draw_rle_sprite(dbuff, (RLE_SPRITE*)gamedat[RAMKA].dat,0,0);
draw_map();
while (!gmex)
 {
 //

text_mode(-1);
if (
   (mouse_x >= scr.width/2) &&
   (mouse_x <= scr.width/2 +text_length((FONT *)gamedat[ZFONT_01].dat,"New game" ) )&&
   (mouse_y >= scr.height/2) &&
   (mouse_y <= scr.height/2+ text_height((FONT *)gamedat[ZFONT_01].dat) )
   ) focus[1]=240; else focus[1]=250;
if (
   (mouse_x>=scr.width/2) &&
   (mouse_x<=scr.width/2+text_length((FONT *)gamedat[ZFONT_01].dat,"Change video mode" ))&&
   (mouse_y>=scr.height/2+20) &&
   (mouse_y<=scr.height/2+20+text_height((FONT *)gamedat[ZFONT_01].dat))
   ) focus[2]=240; else focus[2]=250;
if (
   (mouse_x>=scr.width/2) &&
   (mouse_x<=scr.width/2+text_length((FONT *)gamedat[ZFONT_01].dat,"return to game" ))&&
   (mouse_y>=scr.height/2+40) &&
   (mouse_y<=scr.height/2+40+text_height((FONT *)gamedat[ZFONT_01].dat))
   ) focus[3]=240; else focus[3]=250;
if (
   (mouse_x>=scr.width/2) &&
   (mouse_x<=scr.width/2+text_length((FONT *)gamedat[ZFONT_01].dat,"quit game" ))&&
   (mouse_y>=scr.height/2+60) &&
   (mouse_y<=scr.height/2+60+text_height((FONT *)gamedat[ZFONT_01].dat))
   ) focus[4]=240; else focus[4]=250;
if ((focus[1]==240) && (mouse_b &1) ) pr[1]=1; else pr[1]=0;
if ((focus[2]==240) && (mouse_b &1) ) pr[2]=1; else pr[2]=0;
if ((focus[3]==240) && (mouse_b &1) ) pr[3]=1; else pr[3]=0;
if ((focus[4]==240) && (mouse_b &1) ) pr[4]=1; else pr[4]=0;
 //
 show_mouse(NULL);
textout(dbuff,(FONT *) gamedat[ZFONT_01].dat,"N",scr.width/2 , scr.height/2 ,  255);
textout(dbuff,(FONT *) gamedat[ZFONT_01].dat,"ew game",scr.width/2+9 , scr.height/2 ,  focus[1]);
textout(dbuff,(FONT *) gamedat[ZFONT_01].dat,"C",scr.width/2 , scr.height/2 +20,  255);
textout(dbuff,(FONT *) gamedat[ZFONT_01].dat,"hange Video Mode",scr.width/2+9 , scr.height/2 + 20, focus[2]);
if (mode==1) {
textout(dbuff,(FONT *) gamedat[ZFONT_01].dat,"R",scr.width/2 , scr.height/2 +40,  255);
textout(dbuff,(FONT *) gamedat[ZFONT_01].dat,"eturn to game",scr.width/2 +9, scr.height/2 +40,  focus[3]);
             }else
             {
textout(dbuff,(FONT *) gamedat[ZFONT_01].dat,"Return to game",scr.width/2 , scr.height/2 +40,  32);
             }
textout(dbuff,(FONT *) gamedat[ZFONT_01].dat,"Q", scr.width/2, scr.height/2+60,  255);
textout(dbuff,(FONT *) gamedat[ZFONT_01].dat,"uit game", scr.width/2+9, scr.height/2+60,  focus[4]);
//
textout_centre(dbuff,(FONT *) gamedat[ZFONT_02].dat,
"Forrest Madness", scr.width/2, scr.height/5 - 30,  234);
textout_centre(dbuff,(FONT *) gamedat[ZFONT_01].dat,
"by Evgeni Petkov", scr.width/2, scr.height/5,  0);
textout_centre(dbuff,font,
"keys: arrows move, Ctrl - fire, SPACE - do", scr.width/2, scr.height-20,  255);
//temp=load_bitmap("g_menu.lbm", tp);
//blit(temp,screen,0,0,0,0, scr.width, scr.height);
show_mouse(dbuff);
// blit(dbuff, screen, scr.width/2 , scr.height/2,scr.width/2 , scr.height/2,
// text_length((FONT *)gamedat[ZFONT_01].dat,"Change video mode" ), scr.height/2+78);  // copy it to the screen
 blit(dbuff, screen,0 , 0, 0, 0,
 scr.width, scr.height);  // copy it to the screen
text_mode(255);
 if (key[KEY_N]
 ||
 (pr[1])
 ) {  show_mouse(NULL);
restart_game();return;}
 if (key[KEY_C]
 ||
 (pr[2])
 ) {  show_mouse(NULL);
change_mode();goto ghr;}
 if ( (mode==1)&&
 ( (key[KEY_R])
 ||
 (pr[3]) )
 ) {show_mouse(NULL);
return;}
 if (key[KEY_Q]
 ||
 (pr[4])
 ) {  show_mouse(NULL);
exit(0);}
 }
//destroy_bitmap(temp);
}

//===================
/*void
textout_n (BITMAP * bmp, FONT * f, unsigned char *str, int x, int y, int color)
{
  FONT_PROP *fp;
  BITMAP *b;
  int c, init_x;
  void (*putter) (BITMAP*,BITMAP*, int, int, int);

  init_x = x;

  fp = f->dat.dat_prop;

  putter = bmp->vtable->draw_character;		//bmp->vtable->draw_sprite;

  while (*str)
    {
      c = (int) *str - ' ';
      if (c == (int) ('\n' - ' '))
	{
	  y = y + 16;
	  x = init_x;
	}
      else
	{
	  if ((c < 0) || (c >= FONT_SIZE))
	    c = 0;
	  b = fp->dat[c];
	  if (b)
	    {
	      putter (bmp, b, x, y, color);
	      x += b->w;
	      if (x >= bmp->cr)
		return;
	    }
	}
      str++;
    }
}   */

WORD random(WORD range)
{
  randrange=range;
  asm volatile ("pusha
       movw _randseed2,%ax
       movw _randseed1,%bx
       movw %ax,%si
       movw %bx,%di
       movb %ah,%dl
       movb %al,%ah
       movb %bh,%al
       movb %bl,%bh
       xorb %bl,%bl
       rcrb $1,%dl
       rcrw $1,%ax
       rcrw $1,%bx
       addw %di,%bx
       adcw %si,%ax
       addw $0x62e9,%bx
       adcw $0x3619,%ax
       movw %bx,_randseed2
       movw %ax,_randseed1
       xorw %dx,%dx
       movw _randrange,%cx
       divw %cx
       movw %dx,_randnum
       popa");
  return randnum;
}

void gen_orc()
{
int i;
WORD lg;
     if (lastgen) lg=random((WORD)lastgen)+1; else lg=0;
if ( (!lg) || (enemy_left>=lastbad)|| (!gen[lg].orcs_left)) return;
for (i=1; i<=lastbad; i++)
  {
  if (!all[i].is)
     {
     all[i].am=(3);
     all[i].damage=5;
     all[i].dir=dir_d;
     all[i].subtype=CLEVER;
     all[i].shot_freq=25+random(15);
     all[i].weapon=1;
     all[i].cl=all[i].ll=0;
     all[i].frame=0;
     all[i].pose=osd;
     all[i].x=gen[lg].x;
     all[i].y=gen[lg].y;
     all[i].frame=w_frame[all[i].pose];
     all[i].command=cmd_idle;
     all[i].type=ORC;
     all[i].is=1;
     all[i].health=2;
     enemy_left++;
     gen[lg].orcs_left--;
     return ;
     }
  }
}

void add_bul(int xdir, int ydir, int x, int y, int frame, signed char damage, BYTE ktype)
{
int i;
for (i=0;i<=lastbul;i++)
 {
 if (!bul[i].is)
      {
     	play_sample((SAMPLE *)gamedat[SAM_SHOT].dat, 255, 128, 1000, FALSE);
      bul[i].x=x;
      bul[i].y=y;
      bul[i].frame=frame;
      bul[i].xdir=xdir;
      bul[i].ydir=ydir;
      bul[i].damage=damage;
      bul[i].ktype=ktype;
      bul[i].is=1;
      return ;
      }
 }
}

void do_damage(int who, int dam)
{
all[who].health-=dam;
if (all[who].health <= 0)
   {
  	play_sample((SAMPLE *)gamedat[SAM_DIE].dat, 255, 128, 1000, FALSE);
   all[who].del=0;
   all[who].command=cmd_die;
   all[who].pose=odied1+(random(7)*5);
   }
}

void move_buls()
{
int i, who;
for (i=0;i<=lastbul;i++)
 {
 if (bul[i].is)
      {
          bul[i].x+=bul[i].xdir;
          bul[i].y+=bul[i].ydir;
          bul[i].scrx=bul[i].x-map.x;
          bul[i].scry=bul[i].y-map.y;
          who=whois_bul(bul[i].x, bul[i].y, bul[i].ktype);
          if (who >=0)
              {
      	play_sample((SAMPLE *)gamedat[SAM_HITPL].dat, 255, 128, 1000, FALSE);
              do_damage(who, bul[i].damage);
              bul[i].is=0;
              }
      if (can_move(bul[i].x,bul[i].y)>OT_WATER)
      {
      play_sample((SAMPLE *)gamedat[SAM_HITOBJ].dat, 255, 128, 1000, FALSE);
     bul[i].is=0;
      }
      if ( (bul[i].scrx<=0) ||
          (bul[i].scry<=0) || (bul[i].scrx>=scr.width) ||
          (bul[i].scry>=scr.height)  )
/*      if( (can_move(bul[i].x,bul[i].y)>OT_WATER) || (bul[i].scrx<=BUL_L) ||
          (bul[i].scry<=BUL_U) || (bul[i].scrx>=BUL_R) ||
          (bul[i].scry>=BUL_D)  )*/
            {
            bul[i].is=0;
            }
      }
 }
}

void move_objs()
{
int i;
for (i=0;i<=lastobj;i++)
 {
 if (obj[i].is)
      {
      obj[i].scrx=obj[i].x - map.x;
      obj[i].scry=obj[i].y - map.y;
      if( (obj[i].scrx>=0) &&
          (obj[i].scry>=0) && (obj[i].scrx<=scr.width) &&
          (obj[i].scry<=scr.height)  )
            {
            obj[i].vis=1;
            } else obj[i].vis=0;
      }
 }
}

void load_ctr_g()
{
PACKFILE *ctrf = pack_fopen("john.ctr", "rp");
int n;
   for (n=0; n<JOHN_DAT; n++)
{
      ctr_g[n].x=pack_getc(ctrf);
      ctr_g[n].y=pack_getc(ctrf);
}
pack_fclose(ctrf);
}

void load_ctr_bul()
{
PACKFILE *ctrf = pack_fopen("bul.ctr", "rp");
int n;
   for (n=0; n<BUL_DAT; n++)
{
      ctr_bul[n].x=pack_getc(ctrf);
      ctr_bul[n].y=pack_getc(ctrf);
}
pack_fclose(ctrf);
}

void load_ctr_bstg()
{
PACKFILE *ctrf = pack_fopen("bstg.ctr", "rp"); //
int n;
   for (n=0; n<BUL_DAT; n++)
{
      ctr_bstg[n].x=pack_getc(ctrf);
      ctr_bstg[n].y=pack_getc(ctrf);
}
pack_fclose(ctrf);
// cheat
//      ctr_bstg[0].y+=12;
}

void load_ctr_bsto()
{
PACKFILE *ctrf = pack_fopen("bsto.ctr", "rp");
int n;
   for (n=0; n<BUL_DAT; n++)
{
      ctr_bsto[n].x=pack_getc(ctrf);
      ctr_bsto[n].y=pack_getc(ctrf);
}
pack_fclose(ctrf);
//cheat
//      ctr_bsto[0].y+=12;
}

void load_ctr_o()
{
PACKFILE *ctrf = pack_fopen("orc.ctr", "rp");
int n;
   for (n=0; n<ORC_DAT; n++)
{
      ctr_o[n].x=pack_getc(ctrf);
      ctr_o[n].y=pack_getc(ctrf);
}
pack_fclose(ctrf);
}

BYTE can_move(long cax, long cay)
{
WORD canm_loco;
canm_x=ldiv(cax, map.t_width);
canm_y=ldiv(cay, map.t_height);
canm_loco=map.data[canm_y.quot][canm_x.quot];
canm_type=getpixel((BITMAP *)o_tiles[canm_loco].dat, canm_x.rem, canm_y.rem);
return canm_type;
}

BYTE can_move_g(long cax, long cay)
{
WORD canm_loco;
canm_x=ldiv(cax, map.t_width);
canm_y=ldiv(cay, map.t_height);
canm_loco=map.data[canm_y.quot][canm_x.quot];
canm_type=getpixel((BITMAP *)o_tiles[canm_loco].dat, canm_x.rem, canm_y.rem);
switch (canm_type)
 {
 DOORH1 : if (flag[1]) { map.data[canm_y.quot][canm_x.quot]=tmwalldoor1grh;flag[1]=0; }break;
 DOORV1 : if (flag[1]) { map.data[canm_y.quot][canm_x.quot]=tmwalldoor1grv;flag[1]=0; }break;
// DOORH2 : if (flag[2]) { map.data[canm_u]=tmwalldoor2clgrh;flag[2]=0; }break;
// DOORV2 : if (flag[2]) { map.data[canm_u]=tmwalldoor2clgrv;flag[2]=0; }break;
 }
whois();
 /*if( (cax<=0) ||
   (cay<=0) || (cax>=map.scrwidth) ||
    (cay>=map.scrheight)  ) canm_type=OT_WALL;*/
return canm_type;
}

/*BYTE can_move(long cax, long cay)
{
return 1;
}

BYTE can_move_g(long cax, long cay)
{
return 1;
}    */

int whois() // in real coords
{
int i;
int *wh;
for (i=0; i<=lastobj; i++)
  {
  if ( (obj[i].is) &(obj[i].vis) )
     {
     wh= (int *)objpics[obj[i].frame].dat;
     if  ( (good.x >= obj[i].x) &
     (good.x <=obj[i].x +wh[0])
     &   (good.y >= obj[i].y)
     & (good.y <=obj[i].y +wh[1]) )
         {
          switch (obj[i].type)
          {
          case OB_EXIT : flag[7]=1;break;
          case OB_HEALTH : if (good.health<4) {good.health++;obj[i].is=0;}break;
          case OB_LIFE  : {lives++;obj[i].is=0;}break;
          case OB_RING1 : if (!flag[3]) {flag[3]=1;obj[i].is=0;}break;
          case OB_RING2 : if (!flag[4]) {flag[4]=1;obj[i].is=0;}break;
          case OB_MONEY : { flag[5]++;obj[i].is=0;}break;
          case OB_PRINCESS1 : break;
          }
         }
     }
  }
}

int whois_nn(int wx, int wy) /// in scr coords
{
int i;
int *wh;
for (i=1; i<=lastbad; i++)
  {
  if ( (all[i].is) &(all[i].vis) )
     {
     wh= (int *)opics[all[i].frame].dat;
     if  ( (wx >= all[i].x- ORC_WIDTH) &&
     (wx <=all[i].x + ORC_WIDTH)
     &&   (wy >= all[i].y- ORC_HEIGHT)
     && (wy <=all[i].y ) )
         {
         return i;
         }
     }
  }
return 0;
}

int whois_bul(int wx, int wy, BYTE ktype) //in coords
{
int i;
int *wh;
switch (ktype)
{
       case JOHN:  wh= (int *)goodpics[all[0].frame].dat;
         if  ( (wx >= all[0].x- ctr_g[all[0].frame].x) &
         (wx <=all[0].x- ctr_g[all[0].frame].x + wh[0])
         &   (wy >= all[0].y- ctr_g[all[0].frame].y)
         & (wy <=all[0].y + wh[1])&(all[0].command!=cmd_die) )
         {
         return 0;
         }
         break;
       case ORC:
for (i=1; i<=lastbad; i++)
  {
  if ( (all[i].is) & (all[i].vis) )
     {
         wh= (int *)opics[all[i].frame].dat;
         if  ( (wx >= all[i].x- ctr_o[all[i].frame].x) &
         (wx <=all[i].x + wh[0])
         &   (wy >= all[i].y- ctr_o[all[i].frame].y)
         & (wy <=all[i].y + wh[1])&(all[i].command!=cmd_die) )
         {
         return i;
         }
     }
  }
         break;
}
return -1;
}

void move_good()
{
BYTE wkey=0;
if (good.command == cmd_die) goto end;
/*if ( (good.command == cmd_att) & (good.pose >= hsd) )
{
   good.command=cmd_idle;
         good.keylc=0;
   }*/
//obj
if ( key[KEY_SPACE])
 {
    if ( (obj[wizn].is) && (level==2) && (obj[wizn].x-32 <= good.x ) && (obj[wizn].x+32 >= good.x )
    && (obj[wizn].y-32 <= good.y ) && (obj[wizn].y+32 >= good.y ) )
                          {
                          if ( (flag[5]) >=10 )
                                   {
           textout(screen, (FONT *) gamedat[ZFONT_01].dat,"Here are the money.",good.scrx-50,good.scry-50,0);
          clear_keybuf();
          if (!keypressed()) rest(2000);
       blit(dbuff, screen, 0,0,0,0, scr.width, scr.height);
          textout(screen, (FONT *) gamedat[ZFONT_01].dat,"Good luck.",obj[wizn].scrx-50,obj[wizn].scry-50,0);
          clear_keybuf();
          if (!keypressed()) rest(2000);
       blit(dbuff, screen, 0,0,0,0, scr.width, scr.height);
          flag[6]=1;
          fade_out(1);
          rest(500);
          good.x+=4*32-5;
          fade_in( (PALLETE)gamedat[GPAL].dat, 1);
                                   }
       textout(screen, (FONT *) gamedat[ZFONT_01].dat,"I must cross this river,",good.scrx-50,good.scry-50,0);
       textout(screen, (FONT *) gamedat[ZFONT_01].dat," can I use your boat?   ",good.scrx-50,good.scry-34,0);
       clear_keybuf();
       if (!keypressed()) rest(2000);
       blit(dbuff, screen, 0,0,0,0, scr.width, scr.height);
       textout(screen, (FONT *) gamedat[ZFONT_01].dat,
       "Yes, but you must pay 10 gold",obj[wizn].scrx-50,obj[wizn].scry-50, 0);
       textout(screen, (FONT *) gamedat[ZFONT_01].dat,
       "for this.                    ",obj[wizn].scrx-50,obj[wizn].scry-34, 0);
       clear_keybuf();
       if (!keypressed()) rest(2000);
       blit(dbuff, screen, 0,0,0,0, scr.width, scr.height);
                }
/*       else
       {
       textout(screen, (FONT *) gamedat[ZFONT_01].dat,
       "Good luck.",obj[wizn].scrx-50,obj[wizn].scry-50,0);
       clear_keybuf();
       if (!keypressed()) rest(2000);
       blit(dbuff, screen, 0,0,0,0, scr.width, scr.height);
       textout(screen, (FONT *) gamedat[ZFONT_01].dat,"Thank you!",good.scrx-50,good.scry-50,0);
       clear_keybuf();
       if (!keypressed()) rest(2000);
       blit(dbuff, screen, 0,0,0,0, scr.width, scr.height);
                }*/
 }
//objend
//if (good.command != cmd_att)
{
if ( (key[KEY_UP] ) )  wkey+=1;
if (( key[KEY_RIGHT] ) ) wkey+=2;
if ( ( key[KEY_LEFT] ) ) wkey+=4;
if ((key[KEY_DOWN] )  ) wkey+=8;
if (!key[KEY_CONTROL]) ctrl_p=0;
//if ((scr.beat==good.shot)&& (!key[KEY_CONTROL])) ctrl_p=0;
if ( (key[KEY_CONTROL])&& (!ctrl_p) )
   {
    ctrl_p=1;
//    good.shot=scr.beat+2;
   switch(wkey)
       {
          case 0:
             switch(good.dir)
             {
             case dir_d: b_dirx=0;b_diry=BAM;b_frame=bul_d;break;
             case dir_dr: b_dirx=BAM;b_diry=BAM;b_frame=bul_dr;break;
             case dir_r: b_dirx=BAM;b_diry=0;b_frame=bul_r;break;
             case dir_ur: b_dirx=BAM;b_diry=-BAM;b_frame=bul_ur;break;
             case dir_u: b_dirx=0;b_diry=-BAM;b_frame=bul_u;break;
             case dir_ul: b_dirx=-BAM;b_diry=-BAM;b_frame=bul_ul;break;
             case dir_l: b_dirx=-BAM;b_diry=0;b_frame=bul_l;break;
             case dir_dl: b_dirx=-BAM;b_diry=BAM;b_frame=bul_dl;break;
             }break;
          case 8: b_dirx=0;b_diry=BAM;b_frame=bul_d;break;
          case 10: b_dirx=+BAM;b_diry=BAM;b_frame=bul_dr;break;
          case 2: b_dirx=+BAM;b_diry=0;b_frame=bul_r;break;
          case 3: b_dirx=+BAM;b_diry=-BAM;b_frame=bul_ur;break;
          case 1: b_dirx=0;b_diry=-BAM;b_frame=bul_u;break;
          case 5: b_dirx=-BAM;b_diry=-BAM;b_frame=bul_ul;break;
          case 4: b_dirx=-BAM;b_diry=0;b_frame=bul_l;break;
          case 12: b_dirx=-BAM;b_diry=+BAM;b_frame=bul_dl;break;
       }
   add_bul(b_dirx, b_diry, good.x+ ctr_bstg[b_frame].x,
           good.y+ ctr_bstg[b_frame].y, b_frame, DAM_JOHN, ORC);
//    good.command=cmd_att;
   goto end;
   }
switch (wkey) {
case 0 :
         switch (good.keylc)
          {
          case key_d: good.pose=hsd;break;
          case key_dr: good.pose=hsdr;break;
          case key_r: good.pose=hsr;break;
          case key_ur: good.pose=hsur;break;
          case key_u: good.pose=hsu;break;
          case key_ul: good.pose=hsul;break;
          case key_l: good.pose=hsl;break;
          case key_dl: good.pose=hsdl;break;
          }
         good.keylc=0;
       break;
case 1 :  //u
          if( (can_move_g(good.x, good.y-good.am)<OT_WATER)
          && (good.y>=GOOD_HEIGHT)
           )
          {
           good.keyc=key_u;
           if ( good.keylc != good.keyc) {
                            good.pose=hu1;
                            good.keylc=good.keyc;
                            good.dir=dir_u;
                            good.del=0;
                            }
           if (good.scry < scr.umar)
                         {
                         if (map.y >0) map.y-=map.am;
                         }
            good.y-=good.am;
          }
   break;
case 2 :             ///r
          if ( ( can_move_g(good.x+good.am, good.y)<OT_WATER)
          && (good.x<=map.w_width)
           )
          {
   	good.x+=good.am;
      good.keyc= key_r;
          if (good.keylc != good.keyc)
                            {
                            good.pose=hr1;
                            good.dir=dir_r;
                            good.keylc=good.keyc;
                            good.del=0;
                            }
      if (good.scrx > scr.rmar)
                         { if (map.x <map.scrwidth) map.x+=map.am;
                         }
          }
      break;
case 4 :         ////l
          if ( ( can_move_g(good.x-good.am, good.y)<OT_WATER )
          && (good.x>=GOOD_WIDTH)
           )
          {
	good.x-=good.am;
         good.keyc= key_l;
         if (good.keylc != good.keyc) { good.pose=hl1;
                            good.dir=dir_l;
                            good.keylc=good.keyc;
                            good.del=0;
                            }
      if (good.scrx < scr.lmar)
                         { if (map.x >0) map.x-=map.am;
                         }
          }
       break;
case 8 :     ///d
          if ( ( can_move_g(good.x, good.y+good.am)<OT_WATER   )
          && (good.y<=map.w_height)
           )
          {
	good.y+=good.am;
      good.keyc= key_d;
      if (good.keylc != good.keyc) {good.pose=hd1;
                            good.dir=dir_d;
                            good.keylc=good.keyc;
                            good.del=0;
                            }
      if (good.scry > scr.dmar)
                         { if (map.y <map.scrheight) map.y+=map.am;
                         }
          }
    break;
case 3:  //ur
          if ( ( can_move_g(good.x+good.am, good.y-good.am)<OT_WATER)
          && (good.x<=map.w_width)
          && (good.y>=GOOD_HEIGHT)
           )
          {
	good.y-=good.am;
   good.x+=good.am;
      good.keyc= key_ur;
      if (good.keylc != good.keyc) {good.pose=hur1;
                            good.dir=dir_ur;
                            good.keylc=good.keyc;
                            good.del=0;
                            }
      if (good.scry < scr.umar)
                         {
                         if (map.y >0) map.y-=map.am;
                         }
      if (good.scrx > scr.rmar)
                         { if (map.x <map.scrwidth) map.x+=map.am;
                         }
          }
    break;
case 5:  //ul
          if ( ( can_move_g(good.x-good.am, good.y-good.am)<OT_WATER )
          && (good.y>=GOOD_HEIGHT)
          && (good.x>=GOOD_WIDTH)
           )
          {
	good.y-=good.am;
   good.x-=good.am;
      good.keyc= key_ul;
      if (good.keylc != good.keyc) {good.pose=hul1;
                            good.dir=dir_ul;
                            good.keylc=good.keyc;
                            good.del=0;
                            }
      if (good.scry < scr.umar)
                         {
                         if (map.y >0) map.y-=map.am;
                         }
      if (good.scrx < scr.lmar)
                         { if (map.x >0) map.x-=map.am;
                         }
          }
    break;
case 12:  //dl
          if ( ( can_move_g(good.x-good.am, good.y+good.am)<OT_WATER)
          && (good.x>=GOOD_HEIGHT)
          && (good.y<=map.w_height)
           )
          {
	good.y+=good.am;
   good.x-=good.am;
      good.keyc= key_dl;
      if (good.keylc != good.keyc) {good.pose=hdl1;
                            good.dir=dir_dl;
                            good.keylc=good.keyc;
                            good.del=0;
                            }
      if (good.scry > scr.dmar)
                         { if (map.y <map.scrheight) map.y+=map.am;
                         }
      if (good.scrx < scr.lmar)
                         { if (map.x >0) map.x-=map.am;
                         }
          }
    break;
case 10:  //dr
          if ( ( can_move_g(good.x+good.am, good.y+good.am)<OT_WATER   )
          && (good.x<=map.w_width)
          && (good.y<=map.w_height)
           )
          {
	good.y+=good.am;
   good.x+=good.am;
      good.keyc= key_dr;
      if (good.keylc != good.keyc) {good.pose=hdr1;
                            good.dir=dir_dr;
                            good.keylc=good.keyc;
                            good.del=0;
                            }
      if (good.scry > scr.dmar)
                         { if (map.y <map.scrheight) map.y+=map.am;
                         }
      if (good.scrx > scr.rmar)
                         { if (map.x <map.scrwidth) map.x+=map.am;
                         }
          }
    break;
    }
}
if ( key[KEY_ESC] )
                 { game_menu(1);
                 //good.command=cmd_esc;
                   }
/*if ( key[KEY_C]) //cheat
                 { next_level();
                   }*/
// att NF
end:
good.scrx=good.x-map.x;
good.scry=good.y-map.y;
if (good.del == posedelay[good.pose])
   {
   good.pose=nextpose[good.pose];
   good.del=0;
   }
    else good.del++;
good.frame=w_frame[good.pose];
   if (good.frame == EMP)
      {
      good.is=0;
      lives--;
      if (lives >0) restart_level();
          else
          {
          game_menu(0);
          }
      }
}


void draw_good()
{
draw_sprite(dbuff, (BITMAP *)goodpics[good.frame].dat,
good.scrx- ctr_g[good.frame].x, good.scry- ctr_g[good.frame].y);
/* rectfill(dbuff, good.scrx, good.scry,good.scrx+2, good.scry+2, 0);
 rectfill(dbuff, good.scrx+ctr_bstg[good.frame].x,
 good.scry+ctr_bstg[0].y, good.scrx+ctr_bstg[0].x+2, good.scry+ctr_bstg[0].x+2, 0);
 rectfill(dbuff, good.scrx+ctr_bstg[good.frame].x,
 good.scry+ctr_bstg[1].y, good.scrx+ctr_bstg[1].x+2, good.scry+ctr_bstg[1].x+2, 0);
 rectfill(dbuff, good.scrx+ctr_bstg[good.frame].x,
 good.scry+ctr_bstg[2].y, good.scrx+ctr_bstg[2].x+2, good.scry+ctr_bstg[2].x+2, 0);
 rectfill(dbuff, good.scrx+ctr_bstg[good.frame].x,
 good.scry+ctr_bstg[3].y, good.scrx+ctr_bstg[3].x+2, good.scry+ctr_bstg[3].x+2, 0);
 rectfill(dbuff, good.scrx+ctr_bstg[good.frame].x,
 good.scry+ctr_bstg[4].y, good.scrx+ctr_bstg[4].x+2, good.scry+ctr_bstg[4].x+2, 0);
 rectfill(dbuff, good.scrx+ctr_bstg[good.frame].x,
 good.scry+ctr_bstg[5].y, good.scrx+ctr_bstg[5].x+2, good.scry+ctr_bstg[5].x+2, 0);
 rectfill(dbuff, good.scrx+ctr_bstg[good.frame].x,
 good.scry+ctr_bstg[6].y, good.scrx+ctr_bstg[6].x+2, good.scry+ctr_bstg[6].x+2, 0);
 rectfill(dbuff, good.scrx+ctr_bstg[good.frame].x,
 good.scry+ctr_bstg[7].y, good.scrx+ctr_bstg[7].x+2, good.scry+ctr_bstg[7].x+2, 0);
 */
}

void draw_bul(int who)
{
draw_sprite(dbuff, (BITMAP *)bulpics[bul[who].frame].dat,
bul[who].scrx - ctr_bul[bul[who].frame].x,
bul[who].scry - ctr_bul[bul[who].frame].y);
// rectfill(dbuff, bul[who].scrx, bul[who].scry,bul[who].scrx+2, bul[who].scry+2, 0);
}

void draw_obj(int who)
{
draw_sprite(dbuff, (BITMAP *)objpics[obj[who].frame].dat,
obj[who].scrx , obj[who].scry );
}

void draw_orc(WORD who)
{
draw_sprite(dbuff, (BITMAP *)opics[all[who].frame].dat,
all[who].scrx- ctr_o[all[who].frame].x,
all[who].scry- ctr_o[all[who].frame].y);
// rectfill(dbuff, all[who].scrx, all[who].scry,all[who].scrx+2, all[who].scry+2, 0);
}

void init_good()
{
int i;
good.health=4;
good.command=0;
good.pose=hsd;
good.frame=w_frame[good.pose];
good.am=(4);
good.cl=0;
good.ll=0;
good.type=JOHN;
good.is=1;
good.vis=1;
good.weapon=1;
good.damage=100;
good.dir=dir_u;
for (i=1; i<=lastbad; i++)
  {
all[i].am=(3);
all[i].damage=5;
all[i].dir=dir_u;
all[i].subtype=CLEVER;
all[i].shot_freq=25+random(15);
all[i].weapon=1;
all[i].cl=all[i].ll=0;
all[i].frame=0;
all[i].pose=osd;
all[i].frame=w_frame[all[i].pose];
all[i].command=cmd_idle;
all[i].health=2;
   }
for (i=0; i<=lastbul; i++)
  {
  bul[i].is=0;
  bul[i].type=ARROW;
  bul[i].frame=0;
  }
}

//================================================================= map
void calc_fps()
{
scr.fps++;
}
END_OF_FUNCTION(calc_fps);


void load_map(char *mapfile)
{
	unsigned short magic;
	int i, rdi;
   BYTE br;
	int x, y;
   BYTE rdb, rdb2;
   WORD  rdw;
	// open map file
    FILE *fh;
    fh = fopen (mapfile, "rb");
	// read magic number
	 fread( &magic, 2,1, fh);
	if (magic < 8974)
	{
		fclose(fh);
	}
	// read map width/height
	 fread( &map.width, 2,1, fh);
	 fread( &map.height, 2,1, fh);
	// read map data
 for (i=0; i <= map.height; i++)
 {
	map.data[i]=(WORD*)malloc(map.width*sizeof(WORD)+2);
	fread(map.data[i], 2, (map.width) , fh );
//   if (frtn <(map.width)) exit(6);
  }
for (i=1; i<MAXBAD; i++)
  {
  all[i].is=0;
  all[i].vis=0;
  }
	fread(&lastbad,sizeof(int), 1 , fh );
   enemy_left=lastbad;
   for (i=0; i<=lastbad; i++)
     {
        all[i].is=1;
     	  fread(&all[i].type, 1, 1 , fh );
   	  fread(&all[i].x ,sizeof(int), 1 , fh );
         fread(&all[i].y,sizeof(int), 1 , fh );
     }
   for (i=lastbad+1; i<MAXBAD; i++)
     {
        all[i].is=0;
     }
	fread(&lastobj,sizeof(int), 1 , fh );
   for (i=0; i<=lastobj; i++)
     {
        obj[i].is=1;
     	  fread(&obj[i].type, 1, 1 , fh );
        obj[i].frame=obj[i].type;
   	  fread(&obj[i].x ,sizeof(int), 1 , fh );
         fread(&obj[i].y,sizeof(int), 1 , fh );
         if (obj[i].type == OB_WIZARD1) wizn=i;
     }
lastgen=0;
for (map.y=0; map.y<= map.height; map.y++)
  {
  for (map.x=0; map.x<= map.width; map.x++)
    {
    if (map.data[map.y][map.x] == tmgenorc)
       {
       lastgen++;
       gen[lastgen].x=map.x*map.t_width+6;
       gen[lastgen].y=map.y*map.t_height+32;
       gen[lastgen].is=1;
       gen[lastgen].health=GEN_HEALTH;
       if (level==1) gen[lastgen].orcs_left=6;
       else gen[lastgen].orcs_left=random(15)+1;
       }
    }
  }
           good.scrx=320;
           good.scry=200;
           map.x=good.x - good.scrx;
           map.y=good.y - good.scry;
           if (good.x <= good.scrx) {map.x=0;good.scrx=good.x;}
           if (good.y <= good.scry) {map.y=0;good.scry=good.y;}
	// close map file
   switch (level)
     {
     case 1 : map.popup_rate=400;break;
     case 2 : map.popup_rate=300;break;
//     case 3 : map.popup_rate=400;break;
     case 4 : map.popup_rate=250;break;
     }
   lastbad=(MAXBAD-1);
	fclose(fh);
}

void destroy_map()
{
		free(map.data);
}

void draw_map()
{
map.m_x=ldiv(map.x, map.t_width);
map.m_y=ldiv(map.y, map.t_height);
//map.m_x.rem=(map.t_width-map.m_x.rem);
//map.m_y.rem=(map.t_height-map.m_y.rem);
map.m_x.rem=(-map.m_x.rem);
map.m_y.rem=(-map.m_y.rem);
 tsx=map.m_x.rem;
 tsy=map.m_y.rem;
 umny=map.m_y.quot;
 umn=map.m_x.quot;
 umn1=umn;
 for (ty=0; ty <= scr.t_height; ty++)
 {
  for (tx=0; tx <= scr.t_width; tx++)
  {
  loco=map.data[umny][umn];
   blit( (BITMAP *)tiles[loco].dat, dbuff, 0,0, tsx, tsy, map.t_width, map.t_height);
   tsx+=map.t_width;
   umn++;
  }
 tsx=map.m_x.rem;
 tsy+=map.t_height;
 umny++;
 umn=umn1;
 }
};

void briefing(char *pcxfile)
{
//BITMAP *temp;
//RGB *tp;
draw_map();
play_midi((MIDI *)gamedat[BRIEFING_MID].dat, TRUE);
text_mode(-1);
//draw_rle_sprite(dbuff, (RLE_SPRITE*)gamedat[RAMKA].dat,0,0);
//textprintf_centre(temp,  (FONT *) gamedat[ZFONT_01].dat, scr.width/2, scr.height/2, 255, pcxfile);
textprintf_centre(dbuff,  (FONT *) gamedat[ZFONT_01].dat, scr.width/2, scr.height/2, 250, "LEVEL %i",level);
textprintf_centre(dbuff,  (FONT *) gamedat[ZFONT_01].dat, scr.width/2, scr.height/2+32, 250, pcxfile);
blit(dbuff, screen, 0,0,0,0, scr.width, scr.height);
while (mouse_b & 1) ;
clear_keybuf();
while ( !(mouse_b & 1) & !keypressed() ) ;
text_mode(255);
//destroy_bitmap(temp);
}

void bravo(char *pcxfile)
{
//BITMAP *temp;
//RGB *tp;
draw_map();
play_midi((MIDI *)gamedat[BRAVO_MID].dat, TRUE);
text_mode(-1);
//draw_rle_sprite(dbuff, (RLE_SPRITE*)gamedat[RAMKA].dat,0,0);
//textprintf_centre(temp,  (FONT *) gamedat[ZFONT_01].dat, scr.width/2, scr.height/2, 255, pcxfile);
textprintf_centre(dbuff,  (FONT *) gamedat[ZFONT_01].dat, scr.width/2, scr.height/2, 250, "Congratulations");
textprintf_centre(dbuff,  (FONT *) gamedat[ZFONT_01].dat, scr.width/2, scr.height/2+32, 250, pcxfile);
blit(dbuff, screen, 0,0,0,0, scr.width, scr.height);
while (mouse_b & 1) ;
clear_keybuf();
while ( !(mouse_b & 1) & !keypressed() ) ;
text_mode(255);
//destroy_bitmap(temp);
}

void next_level()
{
bravo(bravos[level]);
if (level<4) level++; else { bravo(bravos[level]); exit(0);} // ending
briefing(briefs[level]);
switch (level)
{
case 1 : play_midi((MIDI *)gamedat[L1_MID].dat, TRUE);break;
case 2 : play_midi((MIDI *)gamedat[L2_MID].dat, TRUE);break;
case 3 : play_midi((MIDI *)gamedat[L3_MID].dat, TRUE);break;
case 4 : play_midi((MIDI *)gamedat[L4_MID].dat, TRUE);break;
}

load_map(levs[level]);
init_game();
init_good();
sort_init();
}

void check_progress()
{
 switch (level)
 {
  case 1 : if (enemy_left <=0) next_level(); break; //kill all
  case 2 : if (flag[7]) next_level(); break;
  case 3 : if (flag[7]) next_level(); break;
  case 4 : if (flag[7]) next_level(); break;
 }
}

void sort_all()
{
for (sort_i=0; sort_i<lastbad; sort_i++)
  {
  if (*redica[sort_i].y > *redica[sort_i+1].y )
     {
     sort_tem=redica[sort_i];
     redica[sort_i]=redica[sort_i+1];
     redica[sort_i+1]=sort_tem;
     sort_i--;
     }
  }
}

void sort_init()
{
WORD i;
for (i=0; i<MAXBAD; i++)
  {
  redica[i].y=&all[i].y;
  redica[i].nr=i;
  redica[i].is=&all[i].vis;
  redica[i].type=&all[i].type;
  }
for (i=MAXBAD; i<(MAXBAD+MAXBULS); i++)
  {
  redica[i].y=&bul[i-MAXBAD].y;
  redica[i].nr=i-MAXBAD;
  redica[i].is=&bul[i-MAXBAD].is;
  redica[i].type=&bul[i-MAXBAD].type;
  }
}


void move_orc( WORD who)
{
if (all[who].command == cmd_die)   goto end;
 all[who].tox=good.x;
 all[who].toy=good.y;
 path_dx=all[who].tox-all[who].x;
 path_dy=all[who].toy-all[who].y;
// if ( (all[who].command != cmd_att) &&(all[who].command != cmd_move) )
// if ( (all[who].command != cmd_move) )
//if (all[who].command==cmd_idle)
if ( (abs(path_dx) < scr.width) && (abs(path_dy) < scr.height) )  // moveto
      {
       if (!random(all[who].shot_freq))
        {
//         all[who].command=cmd_att;
      //   all[who].cl=all[who].ll;
        /*     all[who].dir=0;
            if ( path_dx > 16) all[who].dir+=dir_r;
            else if ( path_dx < -16) all[who].dir+=dir_l;
            if ( path_dy > 16) all[who].dir+=dir_d;
            else if ( path_dy < -16) all[who].dir+=dir_u;
                  all[who].del=0;*/
         switch (all[who].dir)
          {
             case dir_d:b_dirx=0;b_diry=BAM;b_frame=bul_d;break;
             case dir_dr: b_dirx=BAM;b_diry=BAM;b_frame=bul_dr;break;
             case dir_r: b_dirx=BAM;b_diry=0;b_frame=bul_r;break;
             case dir_ur: b_dirx=BAM;b_diry=-BAM;b_frame=bul_ur;break;
             case dir_u: b_dirx=0;b_diry=-BAM;b_frame=bul_u;break;
             case dir_ul:b_dirx=-BAM;b_diry=-BAM;b_frame=bul_ul;break;
             case dir_l: b_dirx=-BAM;b_diry=0;b_frame=bul_l;break;
             case dir_dl: b_dirx=-BAM;b_diry=BAM;b_frame=bul_dl;break;
          }
           add_bul(b_dirx, b_diry, all[who].x+ ctr_bstg[b_frame].x,
           all[who].y+ ctr_bstg[b_frame].y, b_frame, DAM_ORC, JOHN);
        goto end;
        }
//   goto end;
      }
/*if ( (all[who].command == cmd_att) & (all[who].pose >= osd) )
   {
   all[who].command=cmd_idle;
   }  */
 if ( (all[who].command == cmd_idle) &&
  (abs(path_dx) < ORC_VISION) && (abs(path_dy) < ORC_VISION) )  // moveto
 {
  all[who].cl=0;
  all[who].ll=random(32)+1;  // rand()
 all[who].command=cmd_move;
             all[who].dir=0;
            if ( path_dx > 16) all[who].dir+=dir_r;
            else if ( path_dx < -16) all[who].dir+=dir_l;
            else if ( path_dy >0) all[who].dir+=dir_d;
            else if ( path_dy <0) all[who].dir+=dir_u;
            if ( path_dy >16) all[who].dir+=dir_d;
            else if ( path_dy < -16) all[who].dir+=dir_u;
            else   if ( path_dx > 0) all[who].dir+=dir_r;
            else if ( path_dx < 0) all[who].dir+=dir_l;
                  all[who].del=0;
         switch (all[who].dir)
          {
//          case 0 : exit(10);break;
          case dir_d: all[who].pose=od1;all[who].incx=0;all[who].incy=+all[who].am;break;
          case dir_dr: all[who].pose=odr1;all[who].incx=+all[who].am;all[who].incy=+all[who].am;break;
          case dir_r: all[who].pose=or1;all[who].incx=+all[who].am;all[who].incy=0;break;
          case dir_ur: all[who].pose=our1;all[who].incx=+all[who].am;all[who].incy=-all[who].am;break;
          case dir_u: all[who].pose=ou1;all[who].incx=0;all[who].incy=-all[who].am;break;
          case dir_ul: all[who].pose=oul1;all[who].incx=-all[who].am;all[who].incy=-all[who].am;break;
          case dir_l: all[who].pose=ol1;all[who].incx=-all[who].am;all[who].incy=0;break;
          case dir_dl: all[who].pose=odl1;all[who].incx=-all[who].am;all[who].incy=+all[who].am;break;
          }
/*         if ( (abs(path_dx) < ORC_TOOCLOSE) && (abs(path_dy) < ORC_TOOCLOSE))
             {
              all[who].incx=0;
              all[who].incy=0;
         switch (all[who].dir)
          {
          case dir_d: all[who].pose=osd;break;
          case dir_dr: all[who].pose=osdr;break;
          case dir_r: all[who].pose=osr;break;
          case dir_ur: all[who].pose=osur;break;
          case dir_u: all[who].pose=osu;break;
          case dir_ul: all[who].pose=osul;break;
          case dir_l: all[who].pose=osl;break;
          case dir_dl: all[who].pose=osdl;break;
          }
             }*/
         all[who].nx=all[who].x+all[who].incx;
         all[who].ny=all[who].y+all[who].incy;
 goto end;
 }
if (all[who].cl < all[who].ll)
     {
         all[who].cl++;
   if  (all[who].cl == all[who].ll)
        {
        all[who].command=cmd_idle;
        goto end;
        }
  if   (can_move(all[who].nx, all[who].ny) >=OT_WATER)
       {
       all[who].command=cmd_move;
         all[who].cl=0;
           all[who].ll=10 + random(5);  // rand()
        all[who].tox=all[who].x+random(32)- 16;
         all[who].toy=all[who].y+random(32) - 16;
          path_dx=all[who].tox-all[who].x;
           path_dy=all[who].toy-all[who].y;
             all[who].dir=0;
            if ( path_dx > 16) all[who].dir+=dir_r;
            else if ( path_dx < -16) all[who].dir+=dir_l;
            else if ( path_dy >0) all[who].dir+=dir_d;
            else if ( path_dy <0) all[who].dir+=dir_u;
            if ( path_dy >16) all[who].dir+=dir_d;
            else if ( path_dy < -16) all[who].dir+=dir_u;
            else   if ( path_dx > 0) all[who].dir+=dir_r;
            else if ( path_dx < 0) all[who].dir+=dir_l;
                  all[who].del=0;
         switch (all[who].dir)
          {
          case dir_d: all[who].pose=od1;all[who].incx=0;all[who].incy=+all[who].am;break;
          case dir_dr: all[who].pose=odr1;all[who].incx=+all[who].am;all[who].incy=+all[who].am;break;
          case dir_r: all[who].pose=or1;all[who].incx=+all[who].am;all[who].incy=0;break;
          case dir_ur: all[who].pose=our1;all[who].incx=+all[who].am;all[who].incy=-all[who].am;break;
          case dir_u: all[who].pose=ou1;all[who].incx=0;all[who].incy=-all[who].am;break;
          case dir_ul: all[who].pose=oul1;all[who].incx=-all[who].am;all[who].incy=-all[who].am;break;
          case dir_l: all[who].pose=ol1;all[who].incx=-all[who].am;all[who].incy=0;break;
          case dir_dl: all[who].pose=odl1;all[who].incx=-all[who].am;all[who].incy=+all[who].am;break;
          }
/*         if ( (abs(path_dx) < ORC_TOOCLOSE) && (abs(path_dy) < ORC_TOOCLOSE))
             {
              all[who].incx=0;
              all[who].incy=0;
         switch (all[who].dir)
          {
          case dir_d: all[who].pose=osd;break;
          case dir_dr: all[who].pose=osdr;break;
          case dir_r: all[who].pose=osr;break;
          case dir_ur: all[who].pose=osur;break;
          case dir_u: all[who].pose=osu;break;
          case dir_ul: all[who].pose=osul;break;
          case dir_l: all[who].pose=osl;break;
          case dir_dl: all[who].pose=osdl;break;
          }
             }*/
         all[who].nx=all[who].x+all[who].incx;
         all[who].ny=all[who].y+all[who].incy;
       goto end;
       }
             all[who].nx+=all[who].incx;
             all[who].ny+=all[who].incy;
             all[who].x=all[who].nx;
             all[who].y=all[who].ny;
//     all[who].command=cmd_move;
     goto end;
     }
//ending
end:
all[who].scrx=all[who].x-map.x;
all[who].scry=all[who].y-map.y;
if (all[who].del == posedelay[all[who].pose])
   {
   all[who].pose=nextpose[all[who].pose];
   all[who].del=0;
   }
   else all[who].del++;
   all[who].frame=w_frame[all[who].pose];
if ( (all[who].scrx >= 0) & (all[who].scrx<=scr.width)
   & (all[who].scry >= 0) & (all[who].scry<=scr.height) )
   {
   all[who].vis=1;
   }else
   {
   all[who].vis=0;
   }
   if (all[who].frame == EMP)
      {
      all[who].vis=0;
      all[who].is=0;
      enemy_left--;
      }
}

void move_all()
{
for (m_i=0; m_i<=lastbad; m_i++)
  {
  if (all[m_i].is)
     {
        switch (all[m_i].type)
        {
        case JOHN    : move_good();break;
        case ORC     : move_orc(m_i);break;
        }
     }
  }
 move_buls();
 move_objs();
 if (!random(map.popup_rate)) gen_orc();
 check_progress();
}

void debug()
{
textprintf(dbuff, font, 10, 10, 1, "lastgen: %i, enemy: %i",
lastgen, enemy_left);
textprintf(dbuff, font, 10, 20, 1, "lgx: %i, lgy: %i",
gen[lastgen].x, gen[lastgen].y);
textprintf(dbuff, font, 10, 30, 1, "johnx: %i, johny: %i",
good.x, good.y);
}

void draw_icons()
{
int i, y=5;
for (i=100;i<=100+good.health*10; i+=10)
draw_sprite(dbuff, (BITMAP*) gamedat[BITMAP_01].dat,i, y);
for (i=300;i<=300+lives*10; i+=10)
draw_sprite(dbuff, (BITMAP*) objpics[OB_LIFE].dat,i, y);
}


void draw_all()
{
//show_mouse(NULL);
draw_map();
for (d_i=0; d_i<=lastobj; d_i++)
  {
  if ( (obj[d_i].is)&&(obj[d_i].vis)) draw_obj(d_i);
  }
sort_all();
for (d_i=0; d_i<=lastred; d_i++)
  {
  if (*redica[d_i].is)
     {
       switch (*redica[d_i].type)
       {
       case JOHN    : draw_good();break;
       case ORC     :  draw_orc(redica[d_i].nr);break;
       case ARROW   : draw_bul(redica[d_i].nr);break;
       }
     }
  }
//show_mouse(dbuff);
//debug();
draw_icons();
 blit(dbuff, screen, 0, 0, 0, 0,
 scr.width, scr.height);  // copy it to the screen
}

void main(int argc, char *argv[])
{
allegro_init();
override_config_file(".\allegro.cfg");
atexit(game_exit);
if (argc>=2) scr.gspeed=atoi(argv[1]); else scr.gspeed=50;
lives=4;
level=1;
packfile_password("i don't know");
 gamedat=load_datafile("game.dat");
packfile_password(NULL);
#ifndef EDEB
 objpics=load_datafile("obj.dat");
 tiles=load_datafile("tiles.dat");
goodpics=load_datafile("john.dat");
bulpics=load_datafile("bul.dat");
opics=load_datafile("orc.dat");
 o_tiles=load_datafile("o_tiles.dat");
install_keyboard();
install_timer();
   LOCK_VARIABLE(scr.fps);
/*   LOCK_VARIABLE(scr.av_fps);
   LOCK_VARIABLE(scr.min_fps);
   LOCK_VARIABLE(scr.max_fps);*/
   LOCK_FUNCTION(calc_fps);
scr.width=640;
scr.height=400;
 install_mouse();
 set_gfx_mode(GFX_AUTODETECT, scr.width, scr.height, 0, 0);
 show_mouse(NULL);
    if (install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, "") != 0) {
	allegro_exit();
	printf("\nError setting up sound hardware (check sound.cfg settings)\n\n");
	exit(1);
    }
// scr.min_fps=60000;
 set_palette((PALLETE )gamedat[GPAL].dat);
dbuff=create_bitmap(scr.width, scr.height);
clear(dbuff);
getwh=(int*)tiles[0].dat;
map.t_width=getwh[0];
map.t_height=getwh[1];
//load_map(levs[level]);
load_ctr_g();
load_ctr_o();
load_ctr_bul();
load_ctr_bstg();
load_ctr_bsto();
 #endif
//map.w_width=map.width*map.t_width - good.am;
//map.w_height=map.height*map.t_height - good.am;
//scr.t_width=scr.width/map.t_width +1;
//scr.t_height=scr.height/map.t_height +1;
set_clip(dbuff, 0, 0,
scr.width , scr.height );
set_clip(screen, 0,0,0,0);
 good.command=0;
scr.lmar= 6*map.t_width;
scr.rmar= scr.width - 6*map.t_width;
scr.umar= 6*map.t_height;
scr.dmar= scr.height - 6*map.t_height;
install_int_ex(calc_fps, BPS_TO_TIMER(scr.gspeed));
map.am=4;
//map.scrheight=(map.height*map.t_height) - scr.height - map.t_height*2;
//map.scrwidth=(map.width*map.t_width) - scr.width - map.t_width*2;
load_map(levs[level]);
init_game();
game_menu(0);
while (good.command != cmd_esc)
{
scr.fps=0;
move_all();
draw_all();
while (!scr.fps) ;
}
exit(0);
}

